/****************************************************************************
*
*   def.h
*   Base data types
*
*   By Ken Reneris
*
*
*
***/


//
// Base types
//

typedef unsigned __int64    UINT64;
typedef unsigned __int32    UINT32;
typedef unsigned short      UINT16;
typedef unsigned char       UINT8;

typedef signed __int64      INT64;
typedef signed short        INT16;
typedef signed __int32      INT32;
typedef signed char         INT8;

typedef unsigned __int32    UINTP;      // UINT that can store a pointer
typedef unsigned __int32    UINTN;      // Process native width UINT
typedef signed __int32      INTN;

typedef unsigned short      WCHAR;
typedef char                CHAR;       // Note: this is SIGNED to match windows

#define MAX_INT32           0x7fffffff
#define MAX_UINT32          0xffffffff

#define MAX_INT16           0x7fff
#define MAX_UINT16          0xffff

#define MAX_INT8            0x7f
#define MAX_UINT8           0xff


#define MAX_INTN            MAX_INT32
#define MAX_UINTN           MAX_UINT32


//
//
//

typedef float               FLOATN;


//
// compiler
//


#define NULL                0
#define INLINE              __forceinline

#ifndef _BASETSD_H_
    typedef void            VOID;
#endif
