// misc.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

VOID *zalloc(UINTN len)
{
    PVOID       p;

    p = malloc(len);
    ASSERT(p);
    memset(p, 0, len);
    return p;
}


UINTN xtoi(LPCSTR Str)
{
    UINTN       Accum;
    int         a;
    UCHAR       c;

    Accum = 0;
    while (*Str) {
        c = *Str;
        if (c >= 'a' && c <= 'f') {
            a = c - 'a' + 10;
        } else if (c >= 'A' && c <= 'F') {
            a = c - 'A' + 10;
        } else if (c >= '0' && c <= '9') {
            a = c - '0';
        } else {
            break;
        }

        Accum = (Accum << 4) + a;
        Str += 1;
    }

    return Accum;
}


BOOLEAN IsDir(LPCSTR DirName)
{
    CFileStatus     Status;
    BOOLEAN         f;
    
    f = CFile::GetStatus(DirName, Status);
    if (f) {

        if (!(Status.m_attribute & ATTR_DIRECTORY)) {
            f = FALSE;
        }

    } else {
        CString             Str;
        HANDLE              h;
        WIN32_FIND_DATA     FileData;

        // may be the root of a drive... try to do a "dir" on it
        Str.Format("%s\\*", DirName);
        h = FindFirstFile (Str, &FileData);
        if (h != INVALID_HANDLE_VALUE) {
            FindClose(h);
            f = TRUE;
        }
    }

    return f;
}


BOOLEAN IsFile(LPCSTR DirName)
{
    CFileStatus     Status;
    BOOLEAN         f;
    
    f = CFile::GetStatus(DirName, Status);
    return (f != FALSE) && !(Status.m_attribute & ATTR_DIRECTORY);
}

BOOLEAN IsFileOrDir(LPCSTR FileName) 
{
    CFileStatus     Status;
    BOOLEAN         f;
    
    f = CFile::GetStatus(FileName, Status);
    return (f != FALSE);
}

void ExpandDir(CString &DirName)
{
    int         Len, Index;
    CString     Str, DosName;
    CHAR        Buffer[1024];

    memcpy (Buffer, "c:\\", 4);
    Len = DirName.GetLength();
    if (Len < 3) {
        return ;            // weird name.. ignore it
    }

    // if this is a unc name, it's fine the way it is
    if (DirName[0] == '\\'  &&  DirName[1] == '\\') {
        return ;
    }

    // if there's no drive letter, add one
    if (DirName[1] != ':') {
        Buffer[0] = 'c';
        GetCurrentDirectory(sizeof(Buffer), Buffer);
        Str.Format("%c:%s", Buffer[0], DirName);
        DirName = Str;
    }

    // if there's no '\' after the drive letter, just assume the root
    if (DirName[2] != '\\') {
        Str.Format("%s\\%s", DirName.Left(2), DirName.Mid(2));
        DirName = Str;
    }


    // check the drive letter to see if it's a UNC name
    Str.Format("%c:", DirName[0]);
    Str.MakeUpper();
    QueryDosDevice(Str, Buffer, sizeof(Buffer));

    Str = "LanmanRedirector\\";
    DosName = Buffer;
    Index = DosName.Find(Str);
    if (Index < 0) {
        return ;
    }

    Index = Index + Str.GetLength();
    Index = DosName.Find("\\", Index);
    if (Index < 0) {
        return ;
    }

    Str.Format("\\%s%s", DosName.Mid(Index), DirName.Mid(2));
    DirName = Str;
}

//////////////////////////////


VOID DbgPrint(UINTN Flag, LPCSTR Format, ...)
{
    va_list         args;

    if (g_Verbose & Flag) {
        va_start(args, Format);
        vfprintf(stdout, Format, args);
        va_end(args);
    }
}


//////////////////////////////

CExifException::CExifException(LPCSTR Msg, ...)
{
    va_list         args;
    
    va_start(args, Msg);
    m_Message.FormatV(Msg, args);
    va_end(args);
}



//////////////////////////////

VOID Swiz16(UCHAR *Buffer)
{
    UCHAR       l0;

    l0 = Buffer[0];
    Buffer[0] = Buffer[1];
    Buffer[1] = l0;
}

VOID Swiz32(UCHAR *Buffer)
{
    UCHAR       l0, l1, l2;

    l0 = Buffer[0];
    l1 = Buffer[1];
    l2 = Buffer[2];

    Buffer[0] = Buffer[3];
    Buffer[1] = l2;
    Buffer[2] = l1;
    Buffer[3] = l0;
}

VOID SwizR64(UCHAR *Buffer)
// Rationals are 2 32bit values in a row
{
    Swiz32(Buffer);
    Swiz32(Buffer + 4);
}


